(function($) {
    'use strict';
    $(function() {

        $.fn.serializeFormJSON = function() {
            let o = {},
                a = this.serializeArray();
            $.each(a, function() {
                if (o[this.name]) {
                    if (!o[this.name].push) {
                        o[this.name] = [o[this.name]];
                    }
                    o[this.name].push(this.value || '');
                } else {
                    o[this.name] = this.value || '';
                }
            });
            return o;
        };
        //CHECK REQUIRED FIELDS
        $('#ays-sld-form').on('submit', function(e) {
            let data = $(this).serializeFormJSON();
            if (data['ays-image-path[]'] == '') {
                let errorDiv = $(`<div class="apm-alert alert alert-danger alert-dismissible fade show">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    You must upload <strong>images</strong> to make slider.
                </div>`);
                $('#ays-sld-form .apm-alert').fadeOut();
                $('#ays-sld-form').append(errorDiv)
                setTimeout(() => {
                    errorDiv.fadeOut()
                }, 7500);
                e.preventDefault()
                return false;
            }
        });

        $(document).find('.ays_slider_color_input').wpColorPicker();
        $(document).find('.wp-picker-default').val("Default");
        $(document).find('.wp-color-result-text').text("Select Color");

        $(document).find('.nav-tab-wrapper a.nav-tab').on('click', function(e) {
            let elemenetID = $(this).attr('href');
            let active_tab = $(this).attr('data-title');
            $(document).find('.nav-tab-wrapper a.nav-tab').each(function() {
                if ($(this).hasClass('nav-tab-active')) {
                    $(this).removeClass('nav-tab-active');
                }
            });
            $(this).addClass('nav-tab-active');
            $(document).find('.ays-slider-tab-content').each(function() {
                if ($(this).hasClass('ays-slider-tab-content-active'))
                    $(this).removeClass('ays-slider-tab-content-active');
            });
            $('#ays-sld-active-tab').val(active_tab);
            $('.ays-slider-tab-content' + elemenetID).addClass('ays-slider-tab-content-active');
            e.preventDefault();
        });
        $('#ays-button.button-primary').on('click', function() {
            $('#ays-sld-active-tab').val("Images");
        })
        $('#ays-button-top.button-primary').on('click', function() {
            $('#ays-sld-active-tab').val("Images");
        })

        $(document).find('.ays_admin_pages a.ays_page').on('click', function(e) {
            let elemenetID = $(this).attr('href');
            $(document).find('.ays_admin_pages a.ays_page').each(function() {
                if ($(this).hasClass('ays_page_active')) {
                    $(this).removeClass('ays_page_active');
                }
            });
            $(this).addClass('ays_page_active');
            $(document).find('.ays_accordion').each(function() {
                if ($(this).hasClass('ays_accordion_active'))
                    $(this).removeClass('ays_accordion_active');
            });
            $('.paged_ays_accordion .ays_accordion' + elemenetID).addClass('ays_accordion_active');
            e.preventDefault();
        });

        $('#ays-sld-animation-out').change(function() {
            let anim = $(this).val()
            $(this).removeClass().addClass(anim + ' animated').one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {
                $(this).removeClass();
            });
        })
        $('#ays-sld-animation-in').change(function() {
            let anim = $(this).val()
            $(this).removeClass().addClass(anim + ' animated').one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend', function() {
                $(this).removeClass();
            });
        })

        $(document).on('click', '.ays-add-multiple-images', function(e) {
            openMediaUploader_forMultiple(e, $(this));
        });

        $("#ays_admin_pagination").on('change', function(e) {
            $(document).find('#ays_submit_apply').trigger("click");
        });

        $(document).on('click', '.ays_image_add_icon', function(e) {
            openMediaUploader(e, $(this), 'ays_image_add_icon');
        });

        $(document).on('click', '.ays_select_all_images', function(e) {
            if ( $(document).find('ul.ays-accordion').children('li').length <= 0 ) {
                return false;
            }
            $('.ays-accordion').find('.ays_del_li').prop("checked", true);
            $(document).find('.ays_bulk_del_images').prop('disabled', false);
            $(this).addClass("ays_clear_images");
            $(this).removeClass("ays_select_all_images");
        });

        $(document).on('click', '.ays_clear_images', function(e) {
            $('.ays-accordion').find('.ays_del_li').prop("checked", false);
            $(document).find('.ays_bulk_del_images').prop('disabled', true);;
            $(this).addClass("ays_select_all_images");
            $(this).removeClass("ays_clear_images");
        });

        $(document).on('click', '.ays_image_edit', function(e) {
            openMediaUploader(e, $(this), 'ays_image_edit');
        });
        $(document).on('click', 'ul.ays-accordion li .ays_del_li', function(e) {
            $(document).find('.ays_bulk_del_images').prop('disabled', false);
            if ($(document).find('ul.ays-accordion li .ays_del_li:checked').length == 0) {
                $(document).find('.ays_bulk_del_images').prop('disabled', true);
            }

        });

// Code Mirror
             
              setTimeout(function(){
            if($(document).find('#slider_custom_css').length > 0){
                let CodeEditor = null;
                if(wp.codeEditor){
                    CodeEditor = wp.codeEditor.initialize($(document).find('#slider_custom_css'), cm_settings);
                }
                if(CodeEditor !== null){
                    CodeEditor.codemirror.on('change', function(e, ev){
                        $(CodeEditor.codemirror.display.input.div).find('.CodeMirror-linenumber').remove();
                        $(document).find('#slider_custom_css').val(CodeEditor.codemirror.display.input.div.innerText);
                            
                    });
                }
            

            }
        }, 500);
       
          $(document).find('a[href="#tab3"]').on('click', function (e) {        
            setTimeout(function(){
                if($(document).find('#slider_custom_css').length > 0){
                    var slider_custom_css = $(document).find('#slider_custom_css').html();
                    if(wp.codeEditor){
                        $(document).find('#slider_custom_css').next('.CodeMirror').remove();
                        var CodeEditor = wp.codeEditor.initialize($(document).find('#slider_custom_css'), cm_settings);

                        CodeEditor.codemirror.on('change', function(e, ev){
                            $(CodeEditor.codemirror.display.input.div).find('.CodeMirror-linenumber').remove();
                            $(document).find('#slider_custom_css').val(CodeEditor.codemirror.display.input.div.innerText);
                        });
                        slider_custom_css = CodeEditor.codemirror.getValue();
                        $(document).find('#slider_custom_css').html(slider_custom_css);
                    }
                }
            }, 500);
           
        });
           
      
 



        $(document).on('click', '.ays_bulk_del_images', function(e) {
            let accordion = $(document).find('ul.ays-accordion'),
                accordion_el = $(document).find('ul.ays-accordion li .ays_del_li'),
                accordion_el_length = accordion_el.length;
            accordion_el.each(function() {
                if ($(this).prop('checked')) {
                    $(this).parents("li").css({
                        'animation-name': 'slideOutLeft',
                        'animation-duration': '.3s'
                    });
                    let a = $(this);
                    setTimeout(function() {
                        a.parents('li').remove();
                    }, 300);
                }
            });
            setTimeout(function() {
                if ($(document).find('ul.ays-accordion li').length == 0) {
                    $(document).find('div.ays_admin_pages').remove();
                }
            }, 310);
            $(this).prop('disabled', true);
            $(document).find('.ays_clear_images').addClass("ays_select_all_images");
            $(document).find('.ays_select_all_images').removeClass("ays_clear_images");
        });


        // $(document).find('.ays-add-images').on('click', function(e) {
        //     e.preventDefault();
        //     let accordion = $(document).find('ul.ays-accordion'),
        //         accordion_el = $(document).find('ul.ays-accordion li'),
        //         accordion_el_length = accordion_el.length,
        //         ays_title_tooltip = $(document).find("#ays_image_lang_title").val(),
        //         ays_alt_tooltip = $(document).find("#ays_image_lang_alt").val(),
        //         ays_desc_tooltip = $(document).find("#ays_image_lang_desc").val(),
        //         ays_url_tooltip = $(document).find("#ays_image_lang_url").val(),
        //         noimage_path = $(document).find('#noimage_path').val();
        //     let newLi = '<li>' +
        //         '			<i class="fas fa-trash-alt ays-delete-image"></i>' +
        //         '			<i class="fas fa-arrows-alt ays-move-images"></i>' +
        //         '           <div class="ays_del_li_div"><input type="checkbox" class="ays_del_li"/></div>' +
        //         '			<div class="ays_image_add_div">' +
        //         '                <span class="ays_ays_img"></span>' +
        //         '                <div class="ays_image_add_icon"><i class="fas fa-plus ays-upload-btn"></i></div>' +
        //         '           </div>' +
        //         '			<div class="ays_image_thumb" style="display: none;">' +
        //         '			   <div class="ays_image_edit_div">' +
        //         '			       <i class="fas fa-pencil-alt ays_image_edit"></i></div>' +
        //         '			   <img>' +
        //         '			</div>' +
        //         '           <input type="hidden" name="ays-image-path[]">' +
        //         '			<div class="ays-image-attributes">' +
        //         '               <div class="ays_image_attr_item">' +
        //         '                   <label>Image title' +
        //         '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_title_tooltip + '">' +
        //         '                       <i class="fas fa-info-circle"></i>' +
        //         '                    </a></label>' +
        //         '	                <input class="ays_img_title" type="text" name="ays-image-title[]" placeholder="Image title"/>' +
        //         '               </div>' +
        //         '               <div class="ays_image_attr_item">' +
        //         '                   <label>Image alt' +
        //         '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_alt_tooltip + '">' +
        //         '                       <i class="fas fa-info-circle"></i>' +
        //         '                    </a></label>' +
        //         '                   <input class="ays_img_alt" type="text" name="ays-image-alt[]" placeholder="Image alt"/>' +
        //         '               </div>' +
        //         '               <div class="ays_image_attr_item">' +
        //         '                   <label>Image description' +
        //         '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_desc_tooltip + '">' +
        //         '                       <i class="fas fa-info-circle"></i>' +
        //         '                    </a></label>' +
        //         '                   <input class="ays_img_desc" type="text" name="ays-image-description[]" placeholder="Image description"/>' +
        //         '               </div>' +
        //         '               <div class="ays_image_attr_item">' +
        //         '                   <label>URL' +
        //         '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_url_tooltip + '">' +
        //         '                       <i class="fas fa-info-circle"></i>' +
        //         '                    </a></label>' +
        //         '                   <input class="ays_img_url" type="url" name="ays-image-url[]" placeholder="URL"/>' +
        //         '               </div>' +
        //         '           <input type="hidden" name="ays-image-date[]" class="ays_img_date"/>' +
        //         '           </div>' +
        //         '         </li>';

        //     accordion.append(newLi);
        //     $('[data-toggle="tooltip"]').tooltip();
        // });

        $(document).find('ul.ays-accordion').sortable({
            handle: '.fa-arrows-alt',
            axis: 'y',
            opacity: 0.8,
            placeholder: 'clone',
            cursor: 'move'
        });

        $(document).on('click', '.ays-delete-image', function() {
            $(this).parent().css({
                'animation-name': 'slideOutLeft',
                'animation-duration': '.3s'
            });
            var a = $(this);
            setTimeout(function() {
                a.parent().remove();
            }, 300);
        });

        function openMediaUploader(e, element, where) {
            e.preventDefault();
            let aysGalleryUploader = wp.media.frames.items = wp.media({
                title: 'Upload image',
                button: {
                    text: 'Upload'
                },
                library: {
                    type: ['image']
                },
                multiple: false,
                frame: 'select',
            }).on('select', function(e) {
                if (where == 'ays_image_add_icon') {
                    var state = aysGalleryUploader.state();
                    var selection = selection || state.get('selection');
                    if (!selection) return;

                    var attachment = selection.first();
                    var display = state.display(attachment).toJSON();
                    attachment = attachment.toJSON();

                    var d = new Date()
                    var date = d.getTime();
                    date = Math.floor(date / 1000);

                    var imgurl = attachment.url; //sizes[display.size].url;
                    element.parent().parent().children('.ays_image_thumb').children('img').attr('src', imgurl);
                    element.parent().parent().children('.ays_image_thumb').css('display', 'block');
                    element.parent().parent().children('input[type="hidden"]').val(imgurl);
                    element.parent().parent().find('.ays_img_title').val(attachment.title);
                    element.parent().parent().find('.ays_img_alt').val(attachment.title);
                    element.parent().parent().find('.ays_img_date').val(date);
                    element.parent().parent().children('.ays_image_add_div').remove();
                } else {
                    if (where == 'ays_image_edit') {
                        var state = aysGalleryUploader.state();
                        var selection = selection || state.get('selection');
                        if (!selection) return;

                        var attachment = selection.first();
                        var display = state.display(attachment).toJSON();

                        attachment = attachment.toJSON();

                        var d = new Date()
                        var date = d.getTime();
                        date = Math.floor(date / 1000);

                        var imgurl = attachment.url; //sizes[display.size].url;

                        element.parent().parent().children('img').attr('src', imgurl);
                        element.parent().parent().parent().children('input[type="hidden"]').val(imgurl);
                        element.parent().parent().parent().find('.ays_img_title').val(attachment.title);
                        element.parent().parent().parent().find('.ays_img_alt').val(attachment.title);
                        element.parent().parent().parent().find('.ays_img_date').val(date);
                        element.parent().parent().children('img').css('background-image', 'none');
                    }
                }
            }).open();
            return false;

        }

        function openMediaUploader_forMultiple(e, element) {
            e.preventDefault();
            let aysUploader = wp.media.frames.aysUploader = wp.media({
                title: 'Upload images',
                button: {
                    text: 'Upload'
                },
                multiple: true,
                library: {
                    type: ['image']
                },
                frame: "select"
            }).on('select', function() {
                var state = aysUploader.state();
                var selection = selection || state.get('selection');
                if (!selection) return;

                var attachment = selection.first();
                var display = state.display(selection).toJSON();

                var attachment = selection.toJSON();
                var d = new Date()
                var date = d.getTime();
                date = Math.floor(date / 1000);
                //				let attachment = aysUploader.state().get('selection').toJSON();
                for (let i = 0; i < attachment.length; i++) {
                    let accordion = $(document).find('ul.ays-accordion'),
                        accordion_el = $(document).find('ul.ays-accordion li'),
                        ays_title_tooltip = $(document).find("#ays_image_lang_title").val(),
                        ays_alt_tooltip = $(document).find("#ays_image_lang_alt").val(),
                        ays_desc_tooltip = $(document).find("#ays_image_lang_desc").val(),
                        ays_url_tooltip = $(document).find("#ays_image_lang_url").val(),
                        accordion_el_length = accordion_el.length;
                    let newListImage = '<li>' +
                        '			<i class="fas fa-trash-alt ays-delete-image"></i>' +
                        '			<i class="fas fa-arrows-alt ays-move-images"></i>' +
                        '           <div class="ays_del_li_div"><input type="checkbox" class="ays_del_li"/></div>' +
                        '			<div class="ays_image_thumb" style="display: block;">' +
                        '			<div class="ays_image_edit_div">' +
                        '			<i class="fas fa-pencil-alt ays_image_edit"></i></div>' +
                        '			<img class="ays_ays_img" alt="" src="' + attachment[i].url + '">' +
                        '			</div>' +
                        '           <input type="hidden" name="ays-image-path[]" value="' + attachment[i].url + '">' +
                        '			<div class="ays-image-attributes">' +
                        '               <div class="ays_image_attr_item">' +
                        '                   <label>Image title' +
                        '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_title_tooltip + '">' +
                        '                       <i class="fas fa-info-circle"></i>' +
                        '                    </a></label>' +
                        '	                <input class="ays_img_title" type="text" name="ays-image-title[]" value="' + (attachment[i].title) + '" placeholder="Image title"/>' +
                        '               </div>' +
                        '               <div class="ays_image_attr_item">' +
                        '                   <label>Image alt' +
                        '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_alt_tooltip + '">' +
                        '                       <i class="fas fa-info-circle"></i>' +
                        '                    </a></label>' +
                        '                   <input class="ays_img_alt" type="text" name="ays-image-alt[]" value="' + (attachment[i].title) + '" placeholder=""Image alt"/>' +
                        '               </div>' +
                        '               <div class="ays_image_attr_item">' +
                        '                   <label>Image description' +
                        '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_desc_tooltip + '">' +
                        '                       <i class="fas fa-info-circle"></i>' +
                        '                    </a></label>' +
                        '                   <input class="ays_img_desc" type="text" name="ays-image-description[]" placeholder="Image description"/>' +
                        '               </div>' +
                        '               <div class="ays_image_attr_item">' +
                        '                   <label>URL' +
                        '                    <a class="ays_help" data-toggle="tooltip" title="' + ays_url_tooltip + '">' +
                        '                       <i class="fas fa-info-circle"></i>' +
                        '                    </a></label>' +
                        '                   <input class="ays_img_url" type="url" name="ays-image-url[]"  placeholder="URL"/>' +
                        '               </div>' +
                        '           <input type="hidden" name="ays-image-date[]" class="ays_img_date" value="' + (date) + '"/>' +
                        '           </div>' +
                        '         </li>';

                    accordion.append(newListImage);
                    $('[data-toggle="tooltip"]').tooltip();
                }
            }).open();
            return;

        }

        $('[data-toggle="tooltip"]').tooltip();

        function checkThumb() {
            let navType = $('#ays_sld_nav_type').val();
            if (navType == 'thumb') {
                $('.asp-thumbs-options').fadeIn();
            } else {
                $('.asp-thumbs-options').fadeOut();
            }
        }
        checkThumb();
        $('#ays_sld_nav_type').change(checkThumb)

        //thumbs count limit set
        function thumbsLimit() {
            if ($('#slider_width').val() == '') {
                $('#ays-sld-thumb-c-limit').parent().hide()
                $('#ays-sld-thumb-c').attr('max', '')
            } else {
                let sliderWidth = +$('#slider_width').val()
                let thumbWidth = +$('#ays-sld-thumb-w').val()
                let max = Math.floor(sliderWidth / thumbWidth)
                $('#ays-sld-thumb-c-limit').parent().show()
                $('#ays-sld-thumb-c-limit').text(max)
                $('#ays-sld-thumb-c').attr('max', max)
            }
        }
        thumbsLimit()
        $('#ays-sld-thumb-w').change(thumbsLimit)
        $('#slider_width').change(thumbsLimit)

        //filter live preview
        $('.if-filter').css('display', 'flex').hide()

        function applyFilterToImg(filter, val) {
            let cssFilter = '';
            switch (filter) {
                case 'blur':
                    cssFilter = `${filter}(${val}px)`
                    break;
                case 'hue-rotate':
                    cssFilter = `${filter}(${val}deg)`
                    break;
                case 'none':
                    cssFilter = `none`
                    break;
                default:
                    cssFilter = `${filter}(${val})`
                    break;
            }
            $('#ays-filter-example-image').css({
                '-webkit-filter': cssFilter,
                'filter': cssFilter
            })
        }

        function checkFilter() {
            $('#ays-filter-example-image').css({
                '-webkit-filter': 'none',
                'filter': 'none'
            })
            let filter = $('#ays_slider_image_filter').val();
            if (filter != 'none') {
                $('.if-filter').fadeIn()
                let $filter = $(`#${filter}`)
                $('#ays_slider_image_filter_range').children().hide()
                $filter.fadeIn();
                $('#ays-range-value span').text($filter.val())
                $('#ays-range-min').text($filter.attr('min'))
                $('#ays-range-max').text($filter.attr('max'))

                applyFilterToImg(filter, $filter.val())
            } else {
                $('.if-filter').fadeOut()
            }
        }
        checkFilter()
        $('#ays_slider_image_filter').on('change', checkFilter)
        $('#ays_slider_image_filter_range').children().on('input', function() {
            let filter = $(this).attr('id');
            let val = $(this).val()
            $('#ays-range-value span').text(val);
            applyFilterToImg(filter, val)
        })

        let toggle_ddmenu = $(document).find('.toggle_ddmenu');
        toggle_ddmenu.on('click', function () {
            let ddmenu = $(this).next();
            
            let state = ddmenu.attr('data-expanded');
            switch (state) {
                case 'true':
                    $(this).find('.fas').css({
                        transform: 'rotate(0deg)'
                    });
                    ddmenu.attr('data-expanded', 'false');
                    break;
                case 'false':
                    $(this).find('.fas').css({
                        transform: 'rotate(90deg)'
                    });
                ddmenu.attr('data-expanded', 'true');
                break;
            }
        });
    });

})(jQuery);